> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get SCM Integration

> Gets details about a specific SCM integration.

`Unary` · [`Runner Configurations`](/docs/api-reference/generated/runner-configuration/overview)

Gets details about a specific SCM integration.

Use this method to:

* View integration settings
* Check integration status
* Verify configuration

### Examples

* Get integration details:

  Retrieves information about a specific integration.

  ```yaml theme={null}
  id: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.RunnerConfigurationService/GetSCMIntegration
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.RunnerConfigurationService/GetSCMIntegration" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "id": "<id>"
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.runner_configuration_pb2 as runner_configuration_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = runner_configuration_pb2.GetSCMIntegrationRequest(
      id="<id>",
  )
  response = ona.services.runner_configuration.get_scm_integration(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { GetSCMIntegrationRequestSchema } from "@gitpod/sdk/gitpod/v1/runner_configuration_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(GetSCMIntegrationRequestSchema, {
      id: "<id>",
    });
    const response = await ona.services.runnerConfiguration.getSCMIntegration(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.GetSCMIntegrationRequest{
  		Id: "<id>",
  	})
  	response, err := ona.Services.RunnerConfiguration.GetSCMIntegration(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "id": "<id>"
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.GetSCMIntegrationRequest`

| Field | Type   | Required | Description                      |
| ----- | ------ | -------- | -------------------------------- |
| `id`  | string | No       | Constraints: `string.uuid=true`. |

## Response

`gitpod.v1.GetSCMIntegrationResponse`

| Field         | Type                                              | Required | Description |
| ------------- | ------------------------------------------------- | -------- | ----------- |
| `integration` | [SCMIntegration](#type-gitpod-v1-scm-integration) | No       |             |

## Related types

<a id="type-gitpod-v1-scm-integration" />

<Accordion title="SCMIntegration">
  `gitpod.v1.SCMIntegration`

  | Field              | Type                                                                       | Required | Description                                                                                                                                                                                                                                                                                           |
  | ------------------ | -------------------------------------------------------------------------- | -------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
  | `id`               | string                                                                     | No       | id is the unique identifier of the SCM integration                                                                                                                                                                                                                                                    |
  | `scmId`            | string                                                                     | No       | scm\_id references the scm\_id in the runner's configuration schema that this integration is for                                                                                                                                                                                                      |
  | `host`             | string                                                                     | No       |                                                                                                                                                                                                                                                                                                       |
  | `oauth`            | [SCMIntegrationOAuthConfig](#type-gitpod-v1-scm-integration-o-auth-config) | No       |                                                                                                                                                                                                                                                                                                       |
  | `pat`              | boolean                                                                    | No       |                                                                                                                                                                                                                                                                                                       |
  | `runnerId`         | string                                                                     | No       |                                                                                                                                                                                                                                                                                                       |
  | `virtualDirectory` | string                                                                     | No       | virtual\_directory is the virtual directory path for Azure DevOps Server (e.g., "/tfs"). This field is only used for Azure DevOps Server SCM integrations and should be empty for other SCM types. Azure DevOps Server APIs work without collection when PAT scope is 'All accessible organizations'. |
</Accordion>

<a id="type-gitpod-v1-scm-integration-o-auth-config" />

<Accordion title="SCMIntegrationOAuthConfig">
  `gitpod.v1.SCMIntegrationOAuthConfig`

  | Field                   | Type          | Required | Description                                                                                                                                               |
  | ----------------------- | ------------- | -------- | --------------------------------------------------------------------------------------------------------------------------------------------------------- |
  | `clientId`              | string        | No       | client\_id is the OAuth app's client ID in clear text.                                                                                                    |
  | `encryptedClientSecret` | base64 string | No       | encrypted\_client\_secret is the OAuth app's secret encrypted with the runner's public key.                                                               |
  | `issuerUrl`             | string        | No       | issuer\_url is used to override the authentication provider URL, if it doesn't match the SCM host. if not set, this account is owned by the installation. |
</Accordion>
